/*jslint browser: true, unused:false */
/*global $ */

'use strict';

// Função para pegar o numero da pagina na url

function getUrlVars() {
   var lets = {},
       parts = void 0;
   parts = window.location.href.replace(/[?&]+([^=&]+)=([^&]*)/gi, function (m, key, value) {
      lets[key] = value;
   });
   return lets;
}

function range(start, count) {
   return Array.apply(0, new Array(count)).map(function (element, index) {
      return index + start;
   });
}

// Mapeamento das páginas em um array
function pageArray() {
   var pageList = [],
       page = void 0;

   for (var _len = arguments.length, pageIntervals = Array(_len), _key = 0; _key < _len; _key++) {
      pageIntervals[_key] = arguments[_key];
   }

   var pages = pageIntervals.map(function (p) {
      p = p.toString();
      if (p.indexOf('-') === -1) {
         return { type: 'single', number: p };
      } else {
         return { type: 'array', firstPage: Number(p.substr(0, p.indexOf('-'))), lastPage: Number(p.substr(p.indexOf('-') + 1)) };
      }
   });

   for (var i = 0; i < pages.length; i++) {

      if (pages[i].type === 'single') {
         page = Number(pages[i].number);
         pageList.push(page);
      } else {
         for (var x = pages[i].firstPage; x <= pages[i].lastPage; x++) {
            pageList.push(x);
         }
      }
   }
   console.log('Page array: ' + pageList);
   return pageList;
}
// Busca página no localStorage
function setPage(page) {
   localStorage.setItem('mcPage', Number(page));
   return page;
}
// Busca página no localStorage
function getPage() {
   var status = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'reload';


   var page = getUrlVars().page;
   var link = getUrlVars().link;

   if (link === undefined || status !== 'reload') {
      if (page === undefined || status !== 'reload') {
         page = localStorage.getItem('mcPage');
         if (page === null) {
            localStorage.setItem('mcPage', Number(1));
            page = 1;
         }
      } else {
         localStorage.setItem('mcPage', Number(page));
      }
   } else {
      localStorage.setItem('mcPage', Number(link));
      page = link;
   }

   return page;
}

// Exibe paginação com números
function paginationNumbers(listaPaginas, page) {
   var totalPaginas = listaPaginas.length,
       numbersWrap = '.tc-page-numbers';
   var numerosExibicao = void 0,
       totalExibicao = void 0,
       paginasArray = void 0,
       numerosExibicaoEdges = void 0,
       fullExibicao = true;

   $(numbersWrap).html('');
   page = Number(page);

   // Variaveis de limite
   if ($(window).width() > 425) {
      numerosExibicao = 5;
      numerosExibicaoEdges = Math.floor(numerosExibicao / 2);
      totalExibicao = 10;
   } else {
      numerosExibicao = 3;
      numerosExibicaoEdges = Math.floor(numerosExibicao / 2);
      totalExibicao = 5;
   }

   // Exibição dos números
   if (totalPaginas <= totalExibicao) {
      paginasArray = listaPaginas;
   } else {
      fullExibicao = false;
      // Unidade com numero de páginas maior que o total de exibição
      if (page >= numerosExibicao && page <= totalPaginas - numerosExibicao) {
         paginasArray = range(1, numerosExibicaoEdges);
         paginasArray.push('...');
         paginasArray = paginasArray.concat(range(page - numerosExibicaoEdges, numerosExibicao));
         paginasArray.push('...');
         paginasArray = paginasArray.concat(range(totalPaginas - numerosExibicaoEdges + 1, numerosExibicaoEdges));
      } else {
         paginasArray = range(1, numerosExibicao);
         paginasArray.push('...');
         paginasArray = paginasArray.concat(range(totalPaginas - numerosExibicao + 1, numerosExibicao));
      }
   }

   $.each(paginasArray, function (index, value) {
      var text = void 0;
      if (fullExibicao) {
         $(numbersWrap).append('<li aria-label="Página ' + (index + 1) + '" data-key="' + (index + 1) + '">' + (index + 1) + '</li> ');
         if (index + 1 === page) {
            $(numbersWrap + ' li').last().addClass('active');
         }
      } else {
         if (value === '...') {
            $(numbersWrap).append('<li>' + value + '</li> ');
         } else {
            $(numbersWrap).append('<li aria-label="Página ' + value + '" data-key="' + value + '">' + value + '</li> ');
         }

         if (value === page) {
            $(numbersWrap + ' li').last().addClass('active');
         }
      }
   });
}

// carrega a página
function pageLoad(listaPaginas, srcUrl) {
   var page = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : getPage();


   var paginator = '.tc-page-navigator',
       ext = '.html';
   var pageNumber = void 0;

   $(paginator + ' div').removeClass('disabled hide show');

   if (listaPaginas[page - 1] === 1) {
      if ($('#unit-prev').length < 1) {
         $(paginator + ' #page-prev').addClass('disabled');
      } else {
         $(paginator + ' #page-prev').addClass('hide');
         $(paginator + ' #unit-prev').addClass('show');
      }
   }
   if (Number(page) === listaPaginas.length) {
      if ($('#unit-next').length < 1) {
         $(paginator + ' #page-next').addClass('disabled');
      } else {
         $(paginator + ' #page-next').addClass('hide');
         $(paginator + ' #unit-next').addClass('show');
      }
   }

   if (getUrlVars().link === undefined) {
      pageNumber = listaPaginas[page - 1] < 10 ? '0' + listaPaginas[page - 1] : listaPaginas[page - 1];
   } else {
      pageNumber = listaPaginas[page - 1] < 10 ? '0' + listaPaginas[page - 1] : listaPaginas[page - 1];
   }

   $('.tc-page').load(srcUrl + pageNumber + ext, function (response, status, xhr) {
      if (status === 'error') {
         setPage(1);
         pageLoad(listaPaginas, srcUrl, page = 1);
      } else {
         console.log('Carregando a página: ' + srcUrl + pageNumber + ext);
      }

      pageLoadEvents();
   });

   paginationNumbers(listaPaginas, page);
}

// Carrega a paginação
function pagination(listaPaginas) {
   var srcUrl = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'pages/page_';
   var paginator = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '.tc-page-navigator';
   var paginatorNumbers = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '.tc-page-numbers';


   pageLoad(listaPaginas, srcUrl);

   $(document).keydown(function (e) {
      console.log(e.keyCode);

      if (e.keyCode == 37) {
         var page = getPage('load');
         page--;
         setPage(page);
         pageLoad(listaPaginas, srcUrl, page);
      }

      if (e.keyCode == 39) {
         var _page = getPage('load');
         _page++;
         setPage(_page);
         pageLoad(listaPaginas, srcUrl, _page);
      }
   });

   $(paginator + ' #page-prev').click(function () {
      var page = getPage('load');
      page--;
      setPage(page);
      pageLoad(listaPaginas, srcUrl, page);
   });

   $(paginator + ' #page-next').click(function () {
      var page = getPage('load');
      page++;
      setPage(page);
      pageLoad(listaPaginas, srcUrl, page);
   });

   $(paginatorNumbers).on('click', 'li', function () {
      var page = $(this).attr('data-key');
      setPage(page);
      pageLoad(listaPaginas, srcUrl, page);
   });
}